#include <amxmodx>
#include <amxmisc>

public plugin_init(){
	register_plugin("amx_next", "1.0", "LuChan")
	register_dictionary("amx_next.txt")
	register_clcmd("amx_next","cmdNext",ADMIN_BAN,"-sets the nextmap")
	return PLUGIN_CONTINUE
}

public cmdNext(id, level, cid)
{
	if (!cmd_access(id, level, cid, 2))
		return PLUGIN_HANDLED

	new arg[32]
	new arglen = read_argv(1, arg, 31)
	
	if (!is_map_valid(arg))
	{
		console_print(id, "[AMXX]: %L", id, "MAP_NOT_FOUND")
		return PLUGIN_HANDLED
	}

	new authid[32], name[32]
	
	get_user_authid(id, authid, 31)
	get_user_name(id, name, 31)
	
	client_print(0, print_chat, "%L", LANG_PLAYER, "ADMIN_NEXTMAP", name, arg)
	
	log_amx("Cmd: ^"%s<%d><%s><>^" change the nextmap to ^"%s^"", name, get_user_userid(id), authid, arg)
	
	set_cvar_string("amx_nextmap", arg)
	
	return PLUGIN_HANDLED
}