#define ADMIN_FLAG_X (1<<23)
#define ADMIN_LEVEL ADMIN_FLAG_X
#define ADMIN_RESET ADMIN_FLAG_X

//V.I.P
#define VIP_BF2

#if defined VIP_BF2
// Flaga V.i.P
#define VIP ADMIN_LEVEL_H
#endif

#include <amxmodx>
#include <amxmisc>
#include <colorchat>
#include <cstrike>
#include <engine>
#include <fun>
#include <fakemeta>
#include <fakemeta_util>
#include <hamsandwich>
#include <csx>
#include <sqlx>

new const gPluginName[] = "Battlefield 2: Rank Mod";
new const gPluginVersion[] = "1.0.4";
new const gPluginAuthor[] = "MisieQ";
new const gPluginPrefix[] = "TwojaNazwa.pl";
new const gPluginForum[] = "www.TwojaNazwa.pl";
new const gPluginSklep[] = "www.Sklep.TwojaNazwa.pl";
new const gAdminGG[] = "TwojaNazwa GG";
new const gGG[] = "Numer GG";

new const info[][] = { "Slota", "VIP'a", "Rezerwacje Nicku" };

new gmsgStatusText;
new gmsgScreenFade;
new gmsgScreenShake;

new gHUD;
#define TASK_HUD 9897

new gHudSyncAimInfo;
new gMaxPlayers;
new bool:gCZBotRegisterHam;

#define MAX_RANKS 17
#define MAX_BADGES 20

new configsdir[200];
new configfile[200];

//Cvar vars
new gPcvarBF2Active;
new gPcvarBadgesActive;
new gPcvarFreeAwp;
new gPcvarXpMultiplier;
new gPcvarIconTime;
new gPcvarFlagKills;
new gPcvarHelpUrl;
new gPcvarBadgePowers;
new gPcvarFlagRoundPoints;
new gPcvarFlagMatchPoints;
new gPcvarXpMinPlayers;
new gPcvarHudOptions;
new gPcvarStatusText;
new gPcvarFFA;
new gPcvarSaveType;
new gPcvarRankBots;
new gPcvarBotQuota;
new gPcvarSVLan;

//Cvar vars new
new gPcvarWymus;

//Current players info
new g_PlayerRank[33];
new g_PlayerBadges[33][MAX_BADGES];
new knifekills[33];
new pistolkills[33];
new sniperkills[33];
new parakills[33];
new defuses[33];
new plants[33];
new explosions[33];
new accuracy[33];
new totalkills[33];
new gSaveKey[33][32];
new smgkills[33];
new shotgunkills[33];
new riflekills[33];
new grenadekills[33];

new bronze[33];
new silver[33];
new gold[33];

//Temp storage variables
new numofbadges[33];
new bool:newplayer[33];
new g_lastwpn[33];
new bool:g_imobile[33];
new bool:freezetime;
new highestrank;
new highestrankid;
new gStatsLoaded[33];
new gCurrentFOV[33];

new g_friend[33];
new bool:g_invis[33];
new menuselection[33];

//Server stats
new highestrankserver, highestrankservername[32], mostkills, mostkillsid, mostkillsname[32], mostwins, mostwinsname[32];

new menuselected[33][3];
//0 - Badge/Kills selected 0/1
//1 - Badgenum/Kills
//2 - Badgelevel

//Sound Vars
new gSoundRank[] = "bf2rank/bf2rank_promotion.wav"; //Rank gained sound
new gSoundBadge[] = "bf2rank/bf2rank_award.wav"; //Badges earned sound
new gSoundTeleport[] = "bf2rank/teleport.wav"; //Teleport Dzwiek

//Sprite vars
new gSprite[22];

new Handle:g_SqlTuple;
new g_Cache[1024];
new bool:SQLenabled;
new bool:gIntermission;

new gPlayerName;

new ilosc_min_gracza[33];
new bool:ma_miny[33];
new ilosc_teleportow_gracza[33];
new bool:ma_teleport[33];
new sprite_blast;

new gPcvarKasa;

new ak47kills[33];
new m4a1kills[33];
new uspglockkills[33];
new g_trail;
new g_sFlare;

new Ubrania_CT[4][]={"sas","gsg9","urban","gign"};
new Ubrania_TT[4][]={"arctic","leet","guerilla","terror"};
new szTextMenu[256];
new szTextInfo[256];

//Bf2 includes
#include "bf2/const.inl"
#include "bf2/effect.inl"
#include "bf2/cmds.inl"
#include "bf2/save.inl"
#include "bf2/forwards.inl"
#include "bf2/check.inl"
#include "bf2/badgepowers.inl"
#include "bf2/menu.inl"
#include "bf2/hud.inl"
#include "bf2/othermods.inl"
#include "bf2/csx.inl"
#include "bf2/ham.inl"
#include "bf2/sql.inl"
#include "bf2/vip.inl"
#include "bf2/events.inl"
#include "bf2/mina.inl"
#include "bf2/teleport.inl"

#define MEDAL_BRONZE 1
#define MEDAL_SILVER 2
#define MEDAL_GOLD 3

public plugin_init()
{
	register_plugin(gPluginName, gPluginVersion, gPluginAuthor);

	#if defined VIP_BF2
	initVip();
	#endif	

	//Public
	register_clcmd("say /ranks","show_rankhelp",0, "Pokazuje Informacje o Ranku");
	register_clcmd("say_team /ranks","show_rankhelp",0, "Pokazuje Informacje o Ranku");

	register_clcmd("say /badges1","show_badgehelp",0, "Pokazuje Informacje o Odznakach");
	register_clcmd("say_team /badges1","show_badgehelp",0, "Pokazuje Informacje o Odznakach");
	register_clcmd("say /odznaki1","show_badgehelp",0, "Pokazuje Informacje o Odznakach");
	register_clcmd("say_team /odznaki1","show_badgehelp",0, "Pokazuje Informacje o Odznakach");

	register_clcmd("say /badges2","show_badgehelp2",0, "Pokazuje Informacje o Odznakach 2");
	register_clcmd("say_team /badges2","show_badgehelp2",0, "Pokazuje Informacje o Odznakach 2");
	register_clcmd("say /odznaki2","show_badgehelp2",0, "Pokazuje Informacje o Odznakach 2");
	register_clcmd("say_team /odznaki2","show_badgehelp2",0, "Pokazuje Informacje o Odznakach 2");

	register_clcmd("say /badges3","show_badgehelp3",0, "Pokazuje Informacje o Odznakach 3");
	register_clcmd("say_team /badges3","show_badgehelp3",0, "Pokazuje Informacje o Odznakach 3");
	register_clcmd("say /odznaki3","show_badgehelp3",0, "Pokazuje Informacje o Odznakach 3");
	register_clcmd("say_team /odznaki3","show_badgehelp3",0, "Pokazuje Informacje o Odznakach 3");
	
	register_clcmd("say /badges4","show_badgehelp4",0, "Pokazuje Informacje o Odznakach 4");
	register_clcmd("say_team /badges4","show_badgehelp4",0, "Pokazuje Informacje o Odznakach 4");
	register_clcmd("say /odznaki4","show_badgehelp4",0, "Pokazuje Informacje o Odznakach 4");
	register_clcmd("say_team /odznaki4","show_badgehelp4",0, "Pokazuje Informacje o Odznakach 4");
	
	register_clcmd("say /badges5","show_badgehelp5",0, "Pokazuje Informacje o Odznakach 5");
	register_clcmd("say_team /badges5","show_badgehelp5",0, "Pokazuje Informacje o Odznakach 5");
	register_clcmd("say /odznaki5","show_badgehelp5",0, "Pokazuje Informacje o Odznakach 5");
	register_clcmd("say_team /odznaki5","show_badgehelp5",0, "Pokazuje Informacje o Odznakach 5");
	
	register_clcmd("say /badges6","show_badgehelp6",0, "Pokazuje Informacje o Odznakach 6");
	register_clcmd("say_team /badges6","show_badgehelp6",0, "Pokazuje Informacje o Odznakach 6");
	register_clcmd("say /odznaki6","show_badgehelp6",0, "Pokazuje Informacje o Odznakach 6");
	register_clcmd("say_team /odznaki6","show_badgehelp6",0, "Pokazuje Informacje o Odznakach 6");
	
	register_clcmd("say /badges7","show_badgehelp7",0, "Pokazuje Informacje o Odznakach 7");
	register_clcmd("say_team /badges7","show_badgehelp7",0, "Pokazuje Informacje o Odznakach 7");
	register_clcmd("say /odznaki7","show_badgehelp7",0, "Pokazuje Informacje o Odznakach 7");
	register_clcmd("say_team /odznaki7","show_badgehelp7",0, "Pokazuje Informacje o Odznakach 7");

	register_clcmd("say", "cmd_say", 0, "<target> ");
	register_clcmd("say_team", "cmd_say", 0, "<target> ");

	register_clcmd("say /who", "cmd_who", 0, "Wyswietla liste graczy i ich pozimy");
	register_clcmd("say_team /who", "cmd_who", 0, "Wyswietla liste graczy i ich pozimy");
	
	register_clcmd("say /gracze", "cmd_who", 0, "Wyswietla liste graczy i ich pozimy");
	register_clcmd("say_team /gracze", "cmd_who", 0, "Wyswietla liste graczy i ich pozimy");

	register_clcmd("say /help", "cmd_help", 0, "Pokaz pomoc BF2Mod");
	register_clcmd("say_team /help", "cmd_help", 0, "Pokaz pomoc BF2Mod");

	register_clcmd("say /bf2menu", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say_team /bf2menu", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say bf2menu", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say_team bf2menu", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say /bf2", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say_team /bf2", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say bf2", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say_team bf2", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say /menu", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say_team /menu", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say menu", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say_team menu", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say /help", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say_team /help", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say help", "Bf2menu", 0, "Pokazuje Menu");
	register_clcmd("say_team help", "Bf2menu", 0, "Pokazuje Menu");

	register_clcmd("say /bf2helpmenu", "helpmenu", 0, "Pokazuje Menu Pomocy");
	register_clcmd("say_team /bf2helpmenu", "helpmenu", 0, "Pokazuje Menu Pomocy");

	register_clcmd("say /bf2statsmenu", "helpmenu", 0, "Pokazuje Menu Statystyk");
	register_clcmd("say_team /bf2statsmenu", "helpmenu", 0, "Pokazuje Menu Statystyk");

	register_clcmd("say /bf2adminmenu", "adminmenu", 0, "Pokazuje Menu Admina");
	register_clcmd("say_team /bf2adminmenu", "adminmenu", 0, "Pokazuje Menu Admina");

	register_clcmd("say /bf2stats", "show_stats", 0, "Pokazuje twoje aktualne statystyki");
	register_clcmd("say_team /bf2stats", "show_stats", 0, "Pokazuje twoje aktualne statystyki");

	register_clcmd("say /serverstats", "show_server_stats", 0, "Pokazuje aktualne statystyki serwera");
	register_clcmd("say_team /serverstats", "show_server_stats", 0, "Pokazuje aktualne statystyki serwera");

	register_clcmd("say /bf2save", "save_badges", 0, "Zapisuje Aktualne Statystyki");
	register_clcmd("say_team /bf2save", "save_badges", 0, "Zapisuje Aktualne Statystyki");

	//Admin
	register_clcmd("bf2_addbadge", "add_badge", ADMIN_LEVEL, "<player> <badge#> <level#>");
	register_clcmd("bf2_addkills", "add_kills", ADMIN_LEVEL, "<player> <kills#>");
	register_clcmd("teleport", "Teleport" ,-1 ,"Uzyj Teleportu");
	register_clcmd("mina", "PostawMine" ,-1 ,"Postaw Mine");

	//Cvars

	//FCVAR_SERVER cvar for game monitor.
	register_cvar("bf2_version", gPluginVersion, FCVAR_SERVER);

	// Set cvar to update version in case new version loaded while server still running
	set_cvar_string("bf2_version", gPluginVersion);

	gPcvarBF2Active = register_cvar("bf2_active", "1");
	gPcvarBadgesActive = register_cvar("bf2_badges", "1");
	gPcvarFreeAwp = register_cvar("bf2_awp", "0");
	gPcvarXpMultiplier = register_cvar("bf2_xpmultiplier", "0.1");
	gPcvarXpMinPlayers = register_cvar("bf2_xpminplayers", "2");
	gPcvarIconTime = register_cvar("bf2_icon_time", "1.5");
	gPcvarHelpUrl = register_cvar("bf2_help_url", "http://opis.bf2.cs-rabka.eu/");
	gPcvarBadgePowers = register_cvar("bf2_badgepowers", "1");
	gPcvarHudOptions = register_cvar("bf2_hud_options", "abcde");
	gPcvarStatusText = register_cvar("bf2_statustext", "1");
	gPcvarFFA = register_cvar("bf2_ffa", "0");
	gPcvarWymus = register_cvar("bf2_wymus", "1");
	gPcvarFlagKills = register_cvar("bf2_flag_kills", "2");
	gPcvarFlagRoundPoints = register_cvar("bf2_flag_round_kills", "0");
	gPcvarFlagMatchPoints = register_cvar("bf2_flag_match_kills", "0");

	gPcvarSaveType = get_cvar_pointer("csstats_rank");
	gPcvarRankBots = get_cvar_pointer("csstats_rankbots");
	gPcvarBotQuota = get_cvar_pointer("bot_quota");
	gPcvarSVLan = get_cvar_pointer("sv_lan");

	//Message sending.
	gmsgStatusText = get_user_msgid("StatusText");
	gmsgScreenFade = get_user_msgid("ScreenFade");
	gmsgScreenShake = get_user_msgid("ScreenShake");

	//Register events, logs and forwards to be captured
	register_event("HLTV", "Event_HLTV", "a", "1=0", "2=0"); //add freeztime start code
	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1");
	register_event("SetFOV", "Event_SetFOV", "be");
	register_event("DeathMsg", "Event_DeathMsg", "a");

	register_logevent("LogEvent_Round_Start", 2, "0=World triggered", "1=Round_Start"); //freezetime end code
	register_logevent("LogEvent_Round_End", 2, "1=Round_End");

	register_message(SVC_INTERMISSION, "Message_Intermission");
	register_message(get_user_msgid("StatusValue"), "Message_StatusValue");

	register_event("StatusValue", "setTeam", "be", "1=1");
	register_event("StatusValue", "on_ShowStatus", "be", "1=2", "2!0");
	register_event("StatusValue", "on_HideStatus", "be", "1=1", "2=0");

	// Must use post or else is_user_alive will return false when dead player respawns
	RegisterHam(Ham_Spawn, "player", "Ham_Spawn_Post", 1);	// cz bots won't hook here must RegisterHamFromEntity
	RegisterHam(Ham_TakeDamage, "player", "Ham_TakeDamage_Pre");
	RegisterHam(Ham_Killed, "player", "Ham_Death_Player", 1);
	RegisterHam(Ham_Item_Deploy, "weapon_knife", "fwItemDeploy",1);

	gHudSyncAimInfo = CreateHudSyncObj();
	gMaxPlayers = get_maxplayers();
	gPlayerName = get_xvar_id("PlayerName");
	
	register_forward(FM_PlayerPreThink, "FakeMeta_PlayerPreThink")
	
	/* SQL */
	register_cvar("bf2rank_db_host", "10.10.0.101");
	register_cvar("bf2rank_db_user", "s1688");
	register_cvar("bf2rank_db_pass", "47905c40");
	register_cvar("bf2rank_db_database", "serw_s1688");
	
	register_message(get_user_msgid("SayText"),"PrefixCzat");
	
	gHUD = CreateHudSyncObj();
	
	register_touch("Mine", "player", "DotykMiny");
	
	gPcvarKasa = register_cvar("bf2_odznaka_kasa", "150");
	
	set_task(90.0, "medale_info", _, _, _, "b") 
	set_task(120.0, "medale_info", _, _, _, "b")  
	set_task(150.0, "whois_info", _, _, _, "b")  
	set_task(180.0, "whois2_info", _, _, _, "b")  
	
	register_clcmd("say /medale", "medale", 0, "Informacje o swoich medalach");
	register_clcmd("say_team /medale", "medale", 0, "Informacje o swoich medalach");
	
	register_clcmd("say /staty", "staty", 0, "Informacje o swoich statystykach");
	register_clcmd("say_team /staty", "staty", 0, "Informacje o swoich statystykach");
	
	register_clcmd("say /info","ShowMotd2")
	register_clcmd("say team /info","ShowMotd2")
}

public plugin_natives()
{
	register_library("battlefield2");
	register_native("bf2_get_user_badge", "_bf2_get_user_badge");
	register_native("bf2_get_user_rank", "_bf2_get_user_rank");
	register_native("bf2_get_user_medals", "_bf2_get_user_medals");
	register_native("bf2_set_user_badge", "_bf2_set_user_badge");
	register_native("bf2_set_user_rank", "_bf2_set_user_rank");
	register_native("bf2_set_user_medals", "_bf2_set_user_medals");
}

public _bf2_get_user_badge(plugin, params)
{
	if(!is_user_connected(get_param(1))) return 404;
	return g_PlayerBadges[get_param(1)][get_param(2)];
}
public _bf2_get_user_rank(plugin, params)
{
	if(!is_user_connected(get_param(1))) return 404;
	return g_PlayerRank[get_param(1)];
}
public _bf2_get_user_medals(plugin, params)
{
	if(!is_user_connected(get_param(1))) return 404;
	switch(get_param(2))
	{
		case MEDAL_BRONZE:
			return bronze[get_param(1)];
		case MEDAL_SILVER:
			return silver[get_param(1)];
		case MEDAL_GOLD:
			return gold[get_param(1)];
	}
	return g_PlayerRank[get_param(1)];
}
public _bf2_set_user_badge(plugin, params)
{
	if(!is_user_connected(get_param(1))) return 404;
	return g_PlayerBadges[get_param(1)][get_param(2)]=get_param(3);
}
public _bf2_set_user_rank(plugin, params)
{
	if(!is_user_connected(get_param(1))) return 404;
	return g_PlayerRank[get_param(1)]=get_param(2);
}
public _bf2_set_user_medals(plugin, params)
{
	if(!is_user_connected(get_param(1))) return 404;
	switch(get_param(2))
	{
		case MEDAL_BRONZE:
			return bronze[get_param(1)]=get_param(3);
		case MEDAL_SILVER:
			return silver[get_param(1)]=get_param(3);
		case MEDAL_GOLD:
			return gold[get_param(1)]=get_param(3);
	}
	return g_PlayerRank[get_param(1)];
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
